
// #include "stdafx.h"

#include <iostream>
using namespace std;

// #include <windows.h> // win headers;
#include <GL/glut.h> // this one includes the upper two headers;

#include <math.h>
#include <stdlib.h>

int click_x = 0;
int click_y = 0;

//
// initial "screen" parameters;
//
#define ScreenWidth 640
#define ScreenHeight 480

//
// initial win parameters;
//
int win_width = ScreenWidth;
int win_height = ScreenHeight;

//
// texture 
//

#define checkImageWidth 128
#define checkImageHeight 128
static GLubyte checkImage[checkImageHeight][checkImageWidth][3];

static GLuint texName;

void makeCheckImage(void) {

	int i, j, c = 255;

	for (i = 0; i < checkImageHeight; i++) {

		for (j = 0; j < checkImageWidth; j++) {
	
			/* real check board
			if (i % 8 < 4 && j % 8 < 4) {
	
				checkImage[i][j][0] = (GLubyte) c;
				checkImage[i][j][1] = (GLubyte) c;
				checkImage[i][j][2] = (GLubyte) c;
	
			} else if (i % 8 >= 4 && j % 8 >= 4) {
	
				checkImage[i][j][0] = (GLubyte) c;
				checkImage[i][j][1] = (GLubyte) c;
				checkImage[i][j][2] = (GLubyte) c;
	
			} */
	
			// nice try check board;
			c = ( ( (i%4)==0 ) * ( (j%4)==0) ) * 255;
			checkImage[i][j][0] = (GLubyte) c;
			checkImage[i][j][1] = (GLubyte) c;
			checkImage[i][j][2] = (GLubyte) c; 
	
		}

	}

}

void makeMyTexture() {

   makeCheckImage(); // make my bitmap texture image;

   glPixelStorei(GL_UNPACK_ALIGNMENT, 1); // select byte order alignment - i.e. one byte for R, G, B

   glGenTextures(1, &texName); // name my texture; 
   glBindTexture(GL_TEXTURE_2D, texName); // what type is it...

   // black magic. use it like this!
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);

	// finally create texture inside video memory
	glTexImage2D(
		GL_TEXTURE_2D, // the type of texture;
		0, // level of detail, 0 for the beginners; 
		GL_RGB, // texture internal format
		checkImageWidth, // width of our bit mapped texture;
		checkImageHeight, // height of our bitmapped texture;
		0, // image border? 
		GL_RGB, // bitmap texture format
		GL_UNSIGNED_BYTE, // type of bitmap texture data
		checkImage); // pointer to bitmap texture data

}

class Point {
public:
	int x;
	int y;
	Point(int cx = 0, int cy = 0) : x(cx), y(cy) {}
	friend ostream& operator<<(ostream &out, const Point& p);
}; 

ostream& operator<<(ostream &out, const Point& p) {
	out << "(" << p.x << ", " << p.y << ")";
	return out;
}

Point oo;

class Line {
public:
	Point p1;
	Point p2;
	Line(Point cp1 = oo, Point cp2 = oo) : p1(cp1), p2(cp2) {}
	friend ostream& operator<<(ostream &out, const Line& l);
}; 

ostream& operator<<(ostream &out, const Line& l) {
	out << l.p1 << " - " << l.p2;
	return out;
}

#define MAX_PP_COUNT 4

Point pp[MAX_PP_COUNT];
int pp_count = 0;

Line pl[MAX_PP_COUNT];
int pl_count = 0;

int p_ymin = 2048;
int p_ymax = 0;

void drawPolygon() {

	if (pp_count > 2) {

			int i = 0;
			pl_count = 0;

			for(i = 1; i < pp_count; i++) {
					
				if (pp[i-1].y < p_ymin) p_ymin = pp[i-1].y;
				if (pp[i-1].y > p_ymax) p_ymax = pp[i-1].y;

				Line l(pp[i-1], pp[i]);
				pl[pl_count++] = l;

			}

			i = pp_count - 1;
			if (pp[i].y < p_ymin) p_ymin = pp[i].y;
			if (pp[i].y > p_ymax) p_ymax = pp[i].y;

			Line l(pp[i], pp[0]);
			pl[pl_count++] = l;

			glColor3d(255, 255, 0);

			glEnable(GL_TEXTURE_2D); // i'll use texture 

			// how to render texture!
			glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE); // use texture color 
			//glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE); // or modulate with selected color
			glBindTexture(GL_TEXTURE_2D, texName); // which texture i'll use

			glBegin(GL_POLYGON);
			for(i = 0; i < pp_count; i++) {

					if (i == 0) {
						glTexCoord2f (0.0, 0.0);
					} else if (i == 1) {
						glTexCoord2f (1.0, 0.0);
					} else if (i == 2) {
						glTexCoord2f (1.0, 1.0);
					} else if (i == 3) {
						glTexCoord2f (0.0, 1.0);
					} 

					// glTexCoord2f (0.0 + (double) pp[i].x/ (double) win_width, 0.0 + (double) pp[i].y/ (double) win_height); // give texture coords;
					glVertex2i(pp[i].x, pp[i].y);

			}
			glEnd();
			glDisable(GL_TEXTURE_2D); // stop usign texture;


			glColor3d(0, 255, 0);
			glBegin(GL_LINE_LOOP);
			for(i = 0; i < pp_count; i++) {
					glVertex2i(pp[i].x, pp[i].y);

			}
			glEnd(); 

			glColor3d(255, 0, 255);
			glPointSize(5.0);
			for(i = 0; i < pp_count; i++) {
				glBegin(GL_POINTS);
					glVertex2i(pp[i].x, pp[i].y);
				glEnd();
			}

	}

}

void initView() { // what we gonna show;

	glClearColor(0, 0, 0, 0);
	makeMyTexture();

}

void mouse(int button, int state, int mx, int my) {

	if(button == GLUT_LEFT_BUTTON && state == GLUT_DOWN) {

		click_x = mx;
		click_y = win_height - my;

		Point p(click_x, click_y);
		if (pp_count < MAX_PP_COUNT) pp[pp_count++] = p;
		
	} else if (button == GLUT_RIGHT_BUTTON && state == GLUT_DOWN) {

		pp_count = 0;
		pl_count = 0;
		p_ymin = 2048;
		p_ymax = 0;

	}

	glutPostRedisplay();
	
}

void keyboard(unsigned char key, int x, int y)
{
	switch (key)  {
		case 27: // ESCAPE key
			cout << "escape pressed... exitting!" << endl;
			exit(0);
		break;
	}

	// glutPostRedisplay();

}

void keyboard2(int key, int x, int y)
{
	switch (key)  {
		case GLUT_KEY_UP :
			cout << "up key pressed" << endl;
            break;
        case GLUT_KEY_DOWN:
			cout << "down key pressed" << endl;
			break;
        case GLUT_KEY_LEFT:
			cout << "left key pressed" << endl;
            break;
        case GLUT_KEY_RIGHT:
			cout << "right key pressed" << endl;
            break;
	}

	// glutPostRedisplay();

}

void reshape(int w, int h) { // when user moves our window; 

	glViewport(0, 0, w, h); // viewport transofrmation;

	glMatrixMode(GL_PROJECTION); // projection transformation
	glLoadIdentity();

	gluOrtho2D(0.0, w, 0.0, h);

	glMatrixMode(GL_MODELVIEW); // modelling transformation ;; ant glLookAt must be set before that;
	glLoadIdentity();

	win_height = h;
	win_width = w;

}

void display() { // our actual scene;

	glClear(GL_COLOR_BUFFER_BIT); // our color buffer 'll be cleared;

	//drawSpline();
	drawPolygon();

	glFlush();

}

int main(int argc, char *argv[]) { // our main function;

	glutInit(&argc, argv);

    glutInitDisplayMode (GLUT_SINGLE | GLUT_RGB);

    glutInitWindowSize(ScreenWidth, ScreenHeight);
    glutInitWindowPosition(100, 100);

    glutCreateWindow ("Check Texture!");

    initView(); // initialize our 2d view;

    glutDisplayFunc(display); 
	glutReshapeFunc(reshape);

	glutMouseFunc(mouse);

	glutKeyboardFunc(keyboard);
	glutSpecialFunc(keyboard2);

    glutMainLoop(); 

	return 0;

}
